import { AnyFunction, SingleOrMulti } from "./helper-types";
import { ArgsLibPopulator, CompileCache, EnvBasedPopulator, EnvBasedResolver, Expression, FunctionOptions, FunctionParameter, FunctionStep, SpreadableExpression, StepLoopResult, StepNonLoopResult, VariableDeclaration } from "./types";
export declare function compileFunc<V extends AnyFunction = AnyFunction>(options: FunctionOptions, cache: CompileCache, name?: string): EnvBasedResolver<V>;
export declare function compileParam(params: FunctionParameter | FunctionParameter[], cache: CompileCache): ArgsLibPopulator | null;
export declare function compileDecl(decl: SingleOrMulti<VariableDeclaration>, cache: CompileCache): EnvBasedResolver<void> | null;
export declare function compileSpread<V = any>(exp: [], cache: CompileCache): null;
export declare function compileSpread<V = any>(exp: SingleOrMulti<SpreadableExpression>, cache: CompileCache): EnvBasedPopulator<V[]>;
export declare function compileExp<V extends any = any>(exp: Expression[], cache: CompileCache, safe?: boolean): Array<EnvBasedResolver<V>>;
export declare function compileExp<V extends any = any>(exp: Expression, cache: CompileCache, safe?: boolean): EnvBasedResolver<V>;
export declare function compileStep<V = any>(steps: SingleOrMulti<FunctionStep>, cache: CompileCache, breakable: true): EnvBasedResolver<StepLoopResult>;
export declare function compileStep<V = any>(steps: SingleOrMulti<FunctionStep>, cache: CompileCache, breakable?: false | undefined): EnvBasedResolver<StepNonLoopResult>;
export declare function compileStep<V = any>(steps: SingleOrMulti<FunctionStep>, cache: CompileCache, breakable?: boolean | undefined): EnvBasedResolver<StepLoopResult>;
